package util

// Map is a shortcut for creating a json-like object
type Map map[string]interface{}

// Apply is like Object.apply from JS and merges the given objects on top of target
func (target Map) Apply(sources ...Map) Map {
	for _, source := range sources {
		for k, v := range source {
			target[k] = v
		}
	}

	return target
}
